
/*
 * DeJong's f2
 *
 */

#include "GAbench.h"
#include "_error.h"

#ifdef __STDC__
REAL dejong_f2(REAL* x, int n)
#else   
REAL dejong_f2(x,n)
register REAL *x;
int n;  
#endif 
{
	double ans;

#ifdef ERR_CHECK
	if (n != 2)  Erexit("f2 - must be dimension 2");
#endif

	ans = *x * *x - x[1];
	ans *= 100.0*ans;
	ans += (1.0 - *x)*(1.0 - *x);
	return(ans);
}


#ifdef __STDC__
int dejong_df2(REAL *x, int n, REAL *grad)
#else
int dejong_df2(x, n, grad)
REAL *x, *grad;
int n;
#endif 
{
register int i;

#ifdef ERR_CHECK
if (n != 2)  Erexit("df2 - must be dimension 2");
#endif

grad[0] = 400.0 * x[0] * (x[0]*x[0] - x[1]) - 2.0 * (1.0 - x[0]);
grad[1] = - 200.0 * (x[0]*x[0] - x[1]);

return 0;
}

